/*
 * Generated by Digital. Don't modify this file!
 * Any changes will be lost if this file is regenerated.
 */

module Demux2
#(
    parameter Default = 0 
)
(
    output out_0,
    output out_1,
    output out_2,
    output out_3,
    input [1:0] sel,
    input in
);
    assign out_0 = (sel == 2'h0)? in : Default;
    assign out_1 = (sel == 2'h1)? in : Default;
    assign out_2 = (sel == 2'h2)? in : Default;
    assign out_3 = (sel == 2'h3)? in : Default;
endmodule

module LUT_SELECT (
    input \0 ,
    input \1 ,
    input \2 ,
    input \3 ,
    output reg  [1:0]  out
);
    reg [1:0] my_lut [0:15];
    wire [3:0] temp;
    assign temp = {\3 , \2 , \1 , \0 };

    always @ (*) begin
       out = my_lut[temp];
    end

    initial begin
        my_lut[0] = 2'h0;
        my_lut[1] = 2'h1;
        my_lut[2] = 2'h1;
        my_lut[3] = 2'h1;
        my_lut[4] = 2'h1;
        my_lut[5] = 2'h1;
        my_lut[6] = 2'h1;
        my_lut[7] = 2'h1;
        my_lut[8] = 2'h1;
        my_lut[9] = 2'h1;
        my_lut[10] = 2'h9;
        my_lut[11] = 2'h1;
        my_lut[12] = 2'h1;
        my_lut[13] = 2'h1;
        my_lut[14] = 2'h3;
        my_lut[15] = 2'h3;
    end
endmodule

module LUT_ADJUST (
    input \0 ,
    input \1 ,
    input \2 ,
    input \3 ,
    output reg  [7:0]  out
);
    reg [7:0] my_lut [0:15];
    wire [3:0] temp;
    assign temp = {\3 , \2 , \1 , \0 };

    always @ (*) begin
       out = my_lut[temp];
    end

    initial begin
        my_lut[0] = 8'h0;
        my_lut[1] = 8'h0;
        my_lut[2] = 8'h1;
        my_lut[3] = 8'h2;
        my_lut[4] = 8'h3;
        my_lut[5] = 8'h4;
        my_lut[6] = 8'h5;
        my_lut[7] = 8'h6;
        my_lut[8] = 8'h7;
        my_lut[9] = 8'h8;
        my_lut[10] = 8'h9;
        my_lut[11] = 8'ha;
        my_lut[12] = 8'hb;
        my_lut[13] = 8'hc;
        my_lut[14] = 8'h0;
        my_lut[15] = 8'h1;
    end
endmodule


module DIG_Register_BUS #(
    parameter Bits = 1
)
(
    input C,
    input en,
    input [(Bits - 1):0]D,
    output [(Bits - 1):0]Q
);

    reg [(Bits - 1):0] state = 'h0;

    assign Q = state;

    always @ (posedge C) begin
        if (en)
            state <= D;
   end
endmodule

module Mux_4x1_NBits #(
    parameter Bits = 2
)
(
    input [1:0] sel,
    input [(Bits - 1):0] in_0,
    input [(Bits - 1):0] in_1,
    input [(Bits - 1):0] in_2,
    input [(Bits - 1):0] in_3,
    output reg [(Bits - 1):0] out
);
    always @ (*) begin
        case (sel)
            2'h0: out = in_0;
            2'h1: out = in_1;
            2'h2: out = in_2;
            2'h3: out = in_3;
            default:
                out = 'h0;
        endcase
    end
endmodule

module DIG_Add
#(
    parameter Bits = 1
)
(
    input [(Bits-1):0] a,
    input [(Bits-1):0] b,
    input c_i,
    output [(Bits - 1):0] s,
    output c_o
);
   wire [Bits:0] temp;

   assign temp = a + b + c_i;
   assign s = temp [(Bits-1):0];
   assign c_o = temp[Bits];
endmodule



module MAIN (
  input PHI2,
  input RnotW,
  input [7:0] DI,
  input [15:0] AI,
  output [7:0] AO,
  output \~CS_RAM ,
  output \~CS_ROM ,
  output \~CS_VIA0 ,
  output \~CS_VIA1 ,
  output \~CS_VIA2 ,
  output \~CS_VIA3 ,
  output \~RD ,
  output \~WR 
);
  wire [1:0] s0;
  wire [3:0] s1;
  wire s2;
  wire s3;
  wire [7:0] s4;
  wire s5;
  wire [7:0] s6;
  wire s7;
  wire [7:0] s8;
  wire [7:0] s9;
  wire [7:0] s10;
  wire [1:0] s11;
  wire s12;
  wire s13;
  wire s14;
  wire s15;
  wire s16;
  wire \~CS_RAM_temp ;
  wire s17;
  wire s18;
  wire s19;
  wire s20;
  wire [1:0] s21;
  wire IOE;
  wire s22;
  wire s23;
  wire s24;
  wire s25;
  wire s26;
  assign s2 = ~ PHI2;
  assign \~RD  = ~ (RnotW & PHI2);
  assign \~WR  = ~ (PHI2 & ~ RnotW);
  assign IOE = (AI[15] & AI[14] & AI[13] & ~ AI[12] & ~ AI[11] & ~ AI[10] & ~ AI[9] & ~ AI[8]);
  assign s0 = AI[1:0];
  assign s1 = AI[15:12];
  assign s21 = AI[5:4];
  assign s26 = (~ AI[7] & ~ AI[6] & IOE);
  assign s12 = (~ RnotW & ~ AI[7] & AI[6] & ~ AI[5] & ~ AI[4] & ~ AI[3] & ~ AI[2] & IOE);
  assign s13 = s1[0];
  assign s14 = s1[1];
  assign s15 = s1[2];
  assign s16 = s1[3];
  assign s17 = s1[0];
  assign s18 = s1[1];
  assign s19 = s1[2];
  assign s20 = s1[3];
  Demux2 #(
    .Default(0)
  )
  Demux2_i0 (
    .sel( s0 ),
    .in( s12 ),
    .out_0( s3 ),
    .out_1( s5 ),
    .out_2( s7 )
  );
  // SELECT
  LUT_SELECT LUT_SELECT_i1 (
    .\0 ( s13 ),
    .\1 ( s14 ),
    .\2 ( s15 ),
    .\3 ( s16 ),
    .out( s11 )
  );
  // ADJUST
  LUT_ADJUST LUT_ADJUST_i2 (
    .\0 ( s17 ),
    .\1 ( s18 ),
    .\2 ( s19 ),
    .\3 ( s20 ),
    .out( s9 )
  );
  Demux2 #(
    .Default(0)
  )
  Demux2_i3 (
    .sel( s21 ),
    .in( s26 ),
    .out_0( s22 ),
    .out_1( s23 ),
    .out_2( s24 ),
    .out_3( s25 )
  );
  // B0
  DIG_Register_BUS #(
    .Bits(8)
  )
  DIG_Register_BUS_i4 (
    .D( DI ),
    .C( s2 ),
    .en( s3 ),
    .Q( s4 )
  );
  // B1
  DIG_Register_BUS #(
    .Bits(8)
  )
  DIG_Register_BUS_i5 (
    .D( DI ),
    .C( s2 ),
    .en( s5 ),
    .Q( s6 )
  );
  // B2
  DIG_Register_BUS #(
    .Bits(8)
  )
  DIG_Register_BUS_i6 (
    .D( DI ),
    .C( s2 ),
    .en( s7 ),
    .Q( s8 )
  );
  assign \~CS_RAM_temp  = (s11[0] & s11[1]);
  assign \~CS_VIA0  = ~ s22;
  assign \~CS_VIA1  = ~ s23;
  assign \~CS_VIA2  = ~ s24;
  assign \~CS_VIA3  = ~ s25;
  Mux_4x1_NBits #(
    .Bits(8)
  )
  Mux_4x1_NBits_i7 (
    .sel( s11 ),
    .in_0( s4 ),
    .in_1( s6 ),
    .in_2( s8 ),
    .in_3( s8 ),
    .out( s10 )
  );
  assign \~CS_ROM  = (~ \~CS_RAM_temp  | IOE);
  DIG_Add #(
    .Bits(8)
  )
  DIG_Add_i8 (
    .a( s9 ),
    .b( s10 ),
    .c_i( 1'b0 ),
    .s( AO )
  );
  assign \~CS_RAM  = \~CS_RAM_temp ;
endmodule
